/***********************************/
/**          Easy Coding          **/
/**Category : Snippets Collection **/
/**@author Eiyeron                **/
/**@contact eiyeron@gmail.com     **/
/**@file ECode.h                  **/
/**Version : 1.00                 **/
/**Date of creation : 06/28/2011  **/
/***********************************/

#ifndef EASYCODE
#define EASY_CODE

/****************************************************/
/** uncomment #define EASY_of functions you want to use **/
/****************************************************/

// #define EASY__ALL	//define all functions
// #define EASY__MODEL
// #define EASY__STRING
// #define EASY__2STR
// #define EASY__2NUM
// #deinfe EASY_ALL_2HEX
// #define EASY__OPS_BITS
// #define EASY__OTHERS

/**MODEL DETECTION**/
// #define EASY_ISEMULATOR
// #define EASY_ISG35P
// #define EASY_ISG75
// #define EASY_ISG85P
// #define EASY_ISG95
// #define EASY_MODELDETECTOR

/**STRING MANIUPLATION**/
// #define EASY_TOLOWER
// #define EASY_TOUPPER
// #define EASY_STRMIRROR
// #define EASY_STRROTATE
// #define EASY_PRINTF
// #define EASY_PRINTN

/**TO STRING**/
// #define EASY_CHAR2STR
#define EASY_UCHAR2STR
// #define EASY_INT2STR
#define EASY_UINT2STR
// #define EASY_FLOAT2STR

/**TO NUMBER**/
// #define EASY_STR2CHAR
#define EASY_STR2UCHAR
// #define EASY_STR2INT
// #define EASY_STR2UINT

/**TO HEX**/
// #define EASY_CHAR2HEX
// #define EASY_INT2HEX

/**BITS OPERATIONS**/
// #define EASY_READ_BIT_CHAR
// #define EASY_UP_BIT_CHAR
// #define EASY_DOWN_BIT_CHAR
// #define EASY_INVERSE_BIT_CHAR
// #define EASY_READ_BIT_INT
// #define EASY_UP_BIT_INT
// #define EASY_DOWN_BIT_INT
// #define EASY_INVERSE_BIT_INT


/**OTHERS**/
#define EASY_INPUT
// #define EASY_NUMARRAY_CHAR
// #define EASY_NUMARRAY_INT

/**USEFUL VARIABLES**/
#define NULL 0
// #define EXIT_SUCCESS 1

/**************************/
/** Functions prototypes **/
/**************************/

typedef enum {EMUlATOR, G35, G75, G85p, G95, UNDEFINED} Model;


/**MODEL DETECTION**/
char isEmulator();
char isG35p75();
char isG75();  // BESOIN DE LA VALEUR!!!
char isG85p();
char isG95();
Model modelDetector();

/**STRING MANIUPLATION**/
char* toLower(unsigned char* str, unsigned int len);
char* toUpper(unsigned char* str, unsigned int len);
char* strMirror(unsigned char* str, unsigned int len);
char* strRotate(unsigned char* str, unsigned int len, unsigned char mov);
void printf(unsigned char x, unsigned char y, unsigned char str, int mode);
void printn(unsigned char x, unsigned char y, int n, unsigned char mode);

/**TO STRING OPERATIONS**/
unsigned char* intToStr(char* c, int n);
unsigned char* uintToStr(char* c, unsigned int n);
unsigned char* charToStr(char* c, char n);
unsigned char* ucharToStr(char* c, unsigned char n);
unsigned char* floatToStr(char* c, float f, int pecision);

/**TO NUMBER**/
char strToChar(char* c);
unsigned char strToUchar(char* c);
int strToInt(char* c);
unsigned int strToUint(char* c);

/**TO HEX**/
char* charToHex(char* result, unsigned char hex);
char* intToHex(char* result, unsigned int hex);

/**BITS OPERATIONS**/
char readBit_char(char num, char index);
char inverseBit_char(char num, char index);
char upBit_char(char num, char index);
char downBit_char(char num, char index);
char readBit_int(int num, char index);
int inverseBit_int(int num, char index);
int upBit_int(int num, char index);
int downBit_int(int num, char index);

/**OTHERS**/
char* input(char* c, int x, int y, int longueur, char nb);
int numArray_char(char* arr);
int numArray_int(char* arr);

/* TODO
I noticed the model type info is stored at 0x80000300 and 0x8024FEE0 (OS 2.00). So the types are: 
*/

#endif //EASYCODE