 /*****************\
 * Casio Fx - 9860*
 * Project: Game  *
 * Name: BOXED    *
 * Author: Eiyeron*
 * File: editor.c *
 * Year: 2011     *
 \*****************/

#include "fxlib.h"
#include "syscall.h"
#include "MonochromeLib.h"
#include "ECode.h"
#include "editor.h"

void Level_Editor()
{
	unsigned char mur[] = {0xFF, 0xBD, 0xFF, 0xFF, 0xFF, 0xFF, 0xBD, 0xFF};
	unsigned char caisse[] = {0x7E, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x7E};
	unsigned char dot[] = {0x00, 0x3C, 0x5E, 0x7E, 0x7E, 0x7E, 0x3C, 0x00};
	unsigned char caissemise[] = {0x7E, 0x81, 0x99, 0xBD, 0xBD, 0x99, 0x81, 0x7E};
	unsigned char persof[] = {0x18, 0x18, 0x00, 0x5A, 0x3C, 0x18, 0x3C, 0x42};
	unsigned char persor[] = {0x18, 0x18, 0x00, 0x1A, 0x1C, 0x18, 0x18, 0x0C};
	unsigned char persol[] = {0x18, 0x18, 0x00, 0x58, 0x38, 0x18, 0x18, 0x30};
	unsigned char blank[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	unsigned char cursor[] = {0x80, 0xC0, 0xA0, 0x90, 0x88, 0xBC, 0xC0, 0x80}; //l=6 h=8
	
	unsigned char* map;
	// unsigned char* mapBuffer;// map + numero + startx + starty + numbox + placed + width + height + separateur
	
	unsigned int key;
	
	unsigned char temp_size[3];
	unsigned char temp_num[5];
	unsigned char sym_degre[] = {0x9C,0};
	
	unsigned char largeur = 0, hauteur = 0;
	unsigned char x = 0, y = 0;
	unsigned char numbox = 0, placed = 0;
	
	int i,j;
	
	ML_clear_vram();
	locate(1,1);
	
	// Demande de la dimension
	Print("Largeur du niveau");
	while(largeur > 16 || largeur == 0)
	{
		for(i=0;i<3;i++)
			temp_size[i] = 0;
		locate(1,2);
		Print("[  ]");
		input(temp_size, 1, 2, 2, 1);
	largeur = strToUchar(temp_size);
	}
	
	locate(1,1);
	Print("Hauteur du niveau");
	while(hauteur > 8 || hauteur == 0)
	{
		for(i=0;i<3;i++)
			temp_size[i] = 0;
		locate(1,2);
		Print("[  ]");
		input(temp_size, 1, 2, 2, 1);
	hauteur = strToUchar(temp_size);
	}
	
	//Allcoation de la memoire pour la map et le buffer de sauvegarde
	map = malloc(largeur * hauteur);
	// mapBuffer = malloc(largeur * hauteur + 7=8);
	
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			map[i*largeur+j] = 0; //initialisation  0
	
	ML_clear_vram();
	ML_bmp_or(cursor, x+3, y+3, 6, 8);
	ML_display_vram();
	
	while(IsKeyUp(KEY_CTRL_EXIT))
	{
		GetKey(&key);
		//Gestion des touches
		if(key == KEY_CTRL_UP && y > 0)
			y--;
		else if(key == KEY_CTRL_DOWN && y < hauteur - 1)
			y++;
		else if(key == KEY_CTRL_LEFT && x > 0)
			x--;
		else if(key == KEY_CTRL_RIGHT && x < largeur - 1)
			x++;

		else if(key == KEY_CTRL_DEL)
			map[y * largeur + x] = 0;
		else if(key == KEY_CTRL_XTT)
			map[y * largeur + x] = M;
		else if(key == KEY_CHAR_LOG)
			map[y * largeur + x] = D;
		else if(key == KEY_CHAR_LN)
			map[y * largeur + x] = B;
		else if(key == KEY_CHAR_SIN)
			map[y * largeur + x] = P;
		else if(key == KEY_CTRL_F1)
		{
			while(IsKeyDown(key));// KEY_CTRL_F1 tentative d'astuce, qui marche...
			ML_clear_vram();
			locate(1,1);
			Print("-------Resume:-------");
			locate(1,2);
			Print("-Largeur: ");
			Print(ucharToStr(temp_num, largeur));
			locate(1,3);
			Print("-Hauteur: ");
			Print(ucharToStr(temp_num, hauteur));
			locate(1,4);
			Print("-N"); Print(sym_degre); Print(" Boites: ");
			Print(ucharToStr(temp_num, numbox));
			locate(1,5);
			Print("-Deja mises: ");
			Print(ucharToStr(temp_num, placed));
			
			ML_display_vram();
			while(IsKeyUp(KEY_CTRL_EXE));
			while(IsKeyDown(KEY_CTRL_EXE));
		}
		else if(key == KEY_CTRL_F2)	
			Explore_Memory();
			
		//Reactualisation de l'ecran, et des stats
		ML_clear_vram();
		numbox = placed = 0;
		for(j=0; j<hauteur; j++)
		{
			for(i=0; i<largeur; i++)
			{
				switch(map[j * largeur + i])
				{
					case M:
					ML_bmp_8_or(mur, 8 * i, 8 * j);
					break;
					
					case D:
					ML_bmp_8_or(dot, 8 * i, 8 * j);
					break;
					
					case B:
					ML_bmp_8_or(caisse, 8 * i, 8 * j);
					numbox++;
					break;
					
					case P:
					ML_bmp_8_or(caissemise, 8 * i, 8 * j);
					numbox++;
					placed++;
					break;
					
				}
			}
		}
		
		ML_bmp_or_cl(cursor, x * 8 + 3, y * 8 + 3, 6, 8);
		ML_display_vram();
		
	}
	
	free(map);
	// free(mapBuffer);
	ML_clear_vram();
}

void Explore_Memory()
{
	int i = 0, j = 0;
	int searchHandle = 0;
	unsigned int numFichiers = 0;
	FONTCHARACTER chemin[] = {'\\','\\','f','l','s','0','\\','*','.','b','x','d',0}; //Finalement, ce sera .bxd
	FONTCHARACTER nomHandle[13]; //le nom en FONTCHARACTER
	FILE_INFO structTrouve;
	FILE_INFO structAvantDernier;
	unsigned char nomFichier[13]; //le nom en char
	unsigned char poidsTemp[7]; //Le tableau contiendra les poids pour print
	unsigned char** listeNoms;
	unsigned int* listePoids;
	
	char poidsFichier[7];

	ML_clear_vram();
	locate(1,1);
	Print("=====Level=Packs=====");

	Bfile_FindFirst(chemin, &searchHandle, nomHandle, &structTrouve);
	if(searchHandle)
	{
		numFichiers++;
		for(i=1;;i++)
		{		
			Bfile_FindNext(searchHandle, nomHandle, &structTrouve);
			if(structTrouve.id == structAvantDernier.id)
				break;
			else 
			{
			numFichiers++;
			structAvantDernier = structTrouve;
			}
		}
	}	
	else
		numFichiers = 0;
	
	listeNoms = malloc(sizeof(char*) * numFichiers);
	listePoids = malloc(sizeof(int) * numFichiers);
	
	for(i=0;i<numFichiers;i++)
		{
			listeNoms[i] = NULL;
			listePoids[i] = 0;
		}
	
	
	
	Bfile_FindFirst(chemin, &searchHandle, nomHandle, &structTrouve);
	if(searchHandle)
	{
		structAvantDernier = structTrouve;
		listeNoms[0] = malloc(13);
		listePoids[0] = structTrouve.dsize;
		for(i=0;i<13;i++)
		{
			nomFichier[i]= nomHandle[i];
			listeNoms[0][i] = nomFichier[i];
		}
		
		for(i=1;i<numFichiers;i++)
		{
				for(j = 0; j < 13; j++)
					nomFichier[i] = 0;
				
				Bfile_FindNext(searchHandle, nomHandle, &structTrouve);
				if(structTrouve.id == structAvantDernier.id)
					break;
				else
				{
					structAvantDernier = structTrouve;
					listeNoms[i] = malloc(13);
					listePoids[i] = structTrouve.dsize;
					for(j = 0; j < 13; j++)
					{
						nomFichier[j]= nomHandle[j];
						listeNoms[i][j] = nomFichier[j];
								
					}

				}
		}
		// COde
		for(i=0;i<numFichiers;i++)
		{
			locate(1,i+2);
			Print(listeNoms[i]);
			locate(16,i+2);
			Print(uintToStr(poidsTemp,listePoids[i]));
		}
		
		ML_display_vram();
		while(IsKeyUp(KEY_CTRL_EXIT));
		while(IsKeyDown(KEY_CTRL_EXIT));
		
		
		
		for(i=0;i<numFichiers;i++)
		{
			if(listeNoms[i])
				free(listeNoms[i]);
		}

	}
	else
	{
		locate(3,4);
		Print("Pas de fichiers");
		locate(2,6);
		Print("[Exit] pour quitter");
		ML_display_vram();
		while(IsKeyUp(KEY_CTRL_EXIT));
		while(IsKeyDown(KEY_CTRL_EXIT));
	}
	
	free(listeNoms);
	free(listePoids);

}